/* 
 * Copyright (c) 2014, 2015, dynatrace and/or its affiliates. All rights reserved.
 * 
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 * 
 * You should have received a copy of the GNU General Public License
 * along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/

import org.dacapo.harness.Callback;
import org.dacapo.harness.CommandLineArgs;

public class DaCapoGCCallback extends Callback {
	
	private long start;

	public DaCapoGCCallback(CommandLineArgs args) {
		super(args);
	}
	
	@Override
	public void start(String benchmark) {
		if(!isWarmup()) {
			start = getTotalGCTime();
		}
		super.start(benchmark);
	}

	@Override
	public void stop() {
		super.stop();
		if(!isWarmup()) {
			long score = getTotalGCTime() - start;
			System.err.println("##### score=" + score);
		}
	}

	private long getTotalGCTime() {
		long time = 0;
		for(java.lang.management.GarbageCollectorMXBean bean : java.lang.management.ManagementFactory.getGarbageCollectorMXBeans()) {
			time += bean.getCollectionTime();
		}
		return time;
	}

}

